import { AfterViewInit, EventEmitter, OnChanges, OnDestroy, Renderer2, SimpleChanges } from "@angular/core";
import { ThemePalette } from "@angular/material/core";
import { EventService } from "./services/event.service";
export declare class MatVideoComponent implements AfterViewInit, OnChanges, OnDestroy {
    private renderer;
    private evt;
    private player;
    private video;
    src: string | MediaStream | MediaSource | Blob;
    title: string;
    autoplay: boolean;
    preload: boolean;
    loop: boolean;
    quality: boolean;
    fullscreen: boolean;
    playsinline: boolean;
    showFrameByFrame: boolean;
    fps: number;
    download: boolean;
    color: ThemePalette;
    spinner: string;
    poster: string;
    keyboard: boolean;
    overlay: boolean;
    muted: boolean;
    mutedChange: EventEmitter<boolean>;
    timeChange: EventEmitter<number>;
    time: number;
    playing: boolean;
    isFullscreen: boolean;
    videoWidth: number;
    videoHeight: number;
    lastTime: number;
    videoLoaded: boolean;
    private srcObjectURL;
    private isMouseMoving;
    private isMouseMovingTimer;
    private isMouseMovingTimeout;
    private events;
    constructor(renderer: Renderer2, evt: EventService);
    ngAfterViewInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    ngOnDestroy(): void;
    load(): void;
    getVideoTag(): HTMLVideoElement | null;
    evLoadedMetadata(event: any): void;
    evMouseMove(event: any): void;
    evTimeUpdate(event: any): void;
    getOverlayClass(activeClass: string, inactiveClass: string): any;
    private setVideoSrc;
}
